#include <windows.h>
#include <stdio.h>
#include <string>
#include <vector>
using namespace std;

void GetModulePath(char *lpOutPath, char *lpInFileName)
{
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_PATH];
	char ext[_MAX_EXT];

	GetModuleFileName(NULL, lpOutPath, 256);
	_splitpath(lpOutPath, drive, dir, fname, ext );
	_makepath(lpOutPath, drive, dir, lpInFileName, "");
}

typedef BOOL (__stdcall *VeryPDFXPS2PDFConverterFunc)(char *lpXPSFile, char *lpPDFFile, char *lpOptions);
typedef void (__stdcall *VeryPDFXPS2PDFSetCodeFunc)(const char *lpRegcode);
VeryPDFXPS2PDFConverterFunc lpVeryPDFXPS2PDFConverter = NULL;
VeryPDFXPS2PDFSetCodeFunc   lpVeryPDFXPS2PDFSetCode = NULL;
BOOL XPS2PDFConverterSDK(const char *lpszLicenseKey, char *lpXPSFile, char *lpPDFFile, char *lpOptions)
{
	if(lpXPSFile == NULL || lpXPSFile[0] == 0)
		return FALSE;
	if(lpPDFFile == NULL || lpPDFFile[0] == 0)
		return FALSE;

	char szPath[_MAX_PATH];
	GetModulePath(szPath,"xps2pdfsdk.dll");
	HINSTANCE hXPS2PDFSDK = LoadLibrary(szPath);
	if(hXPS2PDFSDK == NULL)
		return FALSE;
	
	lpVeryPDFXPS2PDFConverter = (VeryPDFXPS2PDFConverterFunc)GetProcAddress(hXPS2PDFSDK, "VeryPDFXPS2PDFConverter");
	if(lpVeryPDFXPS2PDFConverter == NULL)
		return FALSE;
	
	lpVeryPDFXPS2PDFSetCode =(VeryPDFXPS2PDFSetCodeFunc)GetProcAddress(hXPS2PDFSDK, "VeryPDFXPS2PDFSetCode");
	if(lpVeryPDFXPS2PDFSetCode ==NULL)
		return FALSE;
	
	if(lpszLicenseKey && lpszLicenseKey[0] != 0)
		lpVeryPDFXPS2PDFSetCode(lpszLicenseKey);
	int nResult = lpVeryPDFXPS2PDFConverter(lpXPSFile, lpPDFFile, lpOptions);
	FreeLibrary(hXPS2PDFSDK);
	return nResult;
}


std::wstring strtowstr(const std::string str)
{
    // Convert an ASCII string to a Unicode String
	int nLength = str.length()*2+1;
    std::wstring wstrTo;
    wchar_t *wszTo = new wchar_t[nLength];
    memset(wszTo, 0, sizeof(wchar_t)*nLength);
    MultiByteToWideChar(CP_ACP, 0, str.c_str(), -1, wszTo, (int)nLength);
    wstrTo = wszTo;
    delete[] wszTo;
    return wstrTo;
}

int main(int argc, char* argv[])
{
	if(argc != 3)
	{
		printf("Usage: <in-file> [<out-file>]\n");
		return 0;
	}
	string strLicenseKey = "XXXXXXXXXXXXXXXXXXXXX";
	int nRet = 0;
	nRet = XPS2PDFConverterSDK(strLicenseKey.c_str(), argv[1], argv[2], NULL);
	printf("nRet = %d\n",nRet);
	return nRet;
}
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPTSTR lpCmdLine, int nCmdShow)
{
	return main(__argc,__argv);
}
